function directorySort(a, b) {
  if (a.sortPath < b.sortPath)
    return -1;
  if (a.sortPath > b.sortPath)
    return 1;
  return 0;
}

function compareName(a, b) {
  if (!a.isDirectory() && b.isDirectory())
    return 1;
  if (a.isDirectory() && !b.isDirectory())
    return -1;
  if (a.leafName.toLowerCase() < b.leafName.toLowerCase())
    return -1;
  if (a.leafName.toLowerCase() > b.leafName.toLowerCase())
    return 1;
  return 0;
}

function compareSize(a, b) {
  if (!a.isDirectory() && b.isDirectory())
    return 1;
  if (a.isDirectory() && !b.isDirectory())
    return -1;
  return a.fileSize - b.fileSize;
}

function compareType(a, b) {
  if (!a.isDirectory() && b.isDirectory())
    return 1;
  if (a.isDirectory() && !b.isDirectory())
    return -1;
  if (localTree.getExtension(a.leafName.toLowerCase()) < localTree.getExtension(b.leafName.toLowerCase()))
    return -1;
  if (localTree.getExtension(a.leafName.toLowerCase()) > localTree.getExtension(b.leafName.toLowerCase()))
    return 1;
  return 0;
}

function compareLocalDate(a, b) {
  if (!a.isDirectory() && b.isDirectory())
    return 1;
  if (a.isDirectory() && !b.isDirectory())
    return -1;
  return a.lastModifiedTime - b.lastModifiedTime;
}

function compareLocalAttr(a, b) {
  if (!a.isDirectory() && b.isDirectory())
    return 1;
  if (a.isDirectory() && !b.isDirectory())
    return -1;
  if (localTree.convertPermissions(a.isHidden(), a.permissions) < localTree.convertPermissions(b.isHidden(), b.permissions))
    return -1;
  if (localTree.convertPermissions(a.isHidden(), a.permissions) > localTree.convertPermissions(b.isHidden(), b.permissions))
    return 1;
  return 0;
}

function compareRemoteDate(a, b) {
  if (!a.isDirectory() && b.isDirectory())
    return 1;
  if (a.isDirectory() && !b.isDirectory())
    return -1;
  var aTemp   = a.date;
  var bTemp   = b.date;
  var curDate = new Date();
  if (a.date.indexOf(':') != -1)
    aTemp = aTemp + ' ' + (curDate.getFullYear() - (curDate.getMonth() < gFtp.remoteMonths.search(aTemp.substring(0,3)) / 4 ? 1 : 0));
  if (b.date.indexOf(':') != -1)
    bTemp = bTemp + ' ' + (curDate.getFullYear() - (curDate.getMonth() < gFtp.remoteMonths.search(bTemp.substring(0,3)) / 4 ? 1 : 0));
  return Date.parse(aTemp) - Date.parse(bTemp);
}

function compareRemoteAttr(a, b) {
  if (!a.isDirectory() && b.isDirectory())
    return 1;
  if (a.isDirectory() && !b.isDirectory())
    return -1;
  if (a.permissions < b.permissions)
    return -1;
  if (a.permissions > b.permissions)
    return 1;
  return 0;
}

function compareAccount(a, b) {
  if (a.account.toLowerCase() < b.account.toLowerCase())
    return -1;
  if (a.account.toLowerCase() > b.account.toLowerCase())
    return 1;
  return 0;
}
